/**
 * BlueWhale PHP Framework
 *
 * @version 0.1.1 alpha (09.11.2017)
 * @author Mikhail Shershnyov <useful-soft@yandex.ru>
 * @copyright Copyright (C) 2006-2017 Mikhail Shershnyov. All rights reserved.
 * @link https://bwframework.ru
 * @license The MIT License https://bwframework.ru/license/
 */

/*
 Используется в html_form().
 Служит для обновления CAPTCHA.
 // TODO Смена URL из формы
 */
function captcha_refresh(id){
	// Антикэш.
	var d = new Date();
	//document.getElementById('captcha_'+id).src = '/index.php?_service=captcha&anticache=' + d.getTime();

	bw.get_element('#' + id).src = '/index.php?_service=captcha&anticache=' + d.getTime();

}




function send_form(name){
	var f = document.getElementById(name);
	if( f != null ){
		f.submit();
	}
}

function submit_form( name ){
	send_form( name );
}


function serialize_form( form_id ){

	var arr = $( form_id ).serializeArray();

	var data = {};

	var re = /^(.+)\[\]$/;

	for( var key in arr ) {

		var name = arr[ key ].name;
		var val = arr[ key ].value;

		var matches = name.match(re);

		if( matches != null ){

			name = matches[1];

			if( ( name in data ) == false ){

				data[ name ] = [];

			}

			data[ name ].push( val );

		}
		else {

			data[ name ] = val;

		}


	}



	return data;

}

function ajax_submit_form( form ){

	ajax_action({
		url: $(form).attr('action'),
		data: serialize_form(form)
	});


	return false;

}



/*
 Используется в html_form().
 Служит для сворачивания/разворачивания групп.
 */
function fields_group_roll(id){
	var g = document.getElementById(id);
	var fieldset = $(g).parent();
	var a = $(fieldset).find('legend a');

	if(g.style.display=='block'){
		g.style.display='none';
		// Свёрнуто
		$.cookie(id, 'collapsed');
		$(a).addClass('minimized');
		$(fieldset).addClass('minimized');
	}else{
		g.style.display = 'block';
		// Развёрнуто
		$.cookie(id, 'expanded');
		$(a).removeClass('minimized');
		$(fieldset).removeClass('minimized');
	}
}

function fields_group_init(id){
	var g = document.getElementById(id);
	var fieldset = $(g).parent();
	var a = $(fieldset).find('legend a');

	var state = $.cookie(id);

	if( state == 'collapsed' ){
		g.style.display='none';
		$(a).addClass('minimized');
		$(fieldset).addClass('minimized');
	}else if( state == 'expanded' ){
		g.style.display = 'block';
		$(a).removeClass('minimized');
		$(fieldset).removeClass('minimized');
	}

}

// use in FieldFile
function hide_file_info(n,i){
	$('#'+n).val('');
	$('#'+i).hide();
}


(function( bw ){

	var arr_forms = [];

	function Form( selector, element ){

		var o = this;

		this.element = element;
		this.selector = selector;

		this.set_mode = function( mode ){

			var $input = $(this.element).find('input[name="form_mode"]');

			$input.val( mode );

			var $list = $(this.element).find('.form-mode');

			$list.each(function(){

				if( $(this).hasClass(mode) == true ){

					// TODO Достать из массива отрендеренный html поля.
					var html = form_data[ o.element.getAttribute('id') ][ this.id ];

					$(this).html(html);

					if( this.hasAttribute('data-display') == true ){

						this.style.display = this.getAttribute('data-display');

					}
					else {

						$(this).show();

					}



				}
				else {

					$(this).hide();
					$(this).html('');

				}

			});
 

		}

		return this;

	}

	bw.get_form = function( selector ){

		var el = bw.get_element(selector);

		if( el == null ){

			return null;

		}

		var form = null;

		for( var i = 0; i < arr_forms.length; i++ ){

			var f = arr_forms[ i ];

			if( f.element == el ){

				form = f;

				break;

			}

		}


		if( form == null ){

			form = new Form( selector, el );

			arr_forms.push( form );

		}

		return form;

	}



})( window.bw = window.bw || {} );



function editor_uploader( el, wysiwyg_id, data ){

	if( typeof data == 'undefined' ){

		data = {};

	}

	bw.uploader({
		url: bw.data.controller_url + '?_service=editor_uploader&action=upload',
		files: el.files,
		data: data,
		oncomplete: function( file, files, index, response ){

			if( response.status == 'success' ) {


				// TODO Определять тип редактора.
				var editor = tinyMCE.get(wysiwyg_id);

				if( editor != null ){


					if( response.uploaded_files.length == 1 ){

						var img = editor.getDoc().createElement('img');

						img.addEventListener('load', function(event){

							if( img.width > 200 ){

								img.width = 200;

							}

							editor.execCommand('mceInsertContent', false, img.outerHTML );

						});

						img.src = response.uploaded_files[0].url;



					}



				}



			}

		}
	});

}


function field_url_clear(event){

	event.preventDefault();

	var parent = bw.dom(this).closest('.field_url');

	var input_text = bw.dom(parent).find('input[type="text"]',0);
	var input_hidden = bw.dom(parent).find('input[type="hidden"]',0);

	input_text.value = '';
	input_hidden.value = '';


//	console.log(input_text, input_hidden);


}